#include <stdio.h>
#include <alloc.h>

#define MAXVILLAGES 10000
#define MAXQUERIES 100 

typedef int Tprvok[3]; 
typedef Tprvok Tpole[MAXQUERIES];
typedef int Tvil[MAXVILLAGES][MAXVILLAGES];
typedef Tvil *Pvil;

void sort(Tpole pole,int zac,int kon,int dest)
{
	int i=zac;
	int j=kon;
	int x=pole[(zac+kon)/2][dest];
	Tprvok q;

	do {
		while (pole[i][dest]<x) 
			i++;
		while (pole[j][dest]>x)
			j--;	
		if (i<j) {
			q=pole[i];
			pole[i]=pole[j];
			pole[j]=q;			
		}else if (i==j) {
			i++;
			j--;	
		}
	}while (!(i>j));
	if (zac<j)
		sort(pole,zac,j,dest);
	if (kon>i)
		sort(pole,i,kon,dest); 	
}

int find(Tpole pole,int N,int value)
{
	int i=0;
	int j=N-1;

	do{
		int x=(i+j)/2;
		if (value==pole[i][0]){
			return i;
		}else if (value==pole[j][0]){
			return j;
		}else if (value==pole[x][0]){
			return x;
		}else if (value>pole[x][0]){
			i=x;
		}else{
			j=x;
		}
	}while((j-i)>1);
	return (-1);
}

int browse(Pvil vil,Tpole pole,int used[],int Nvil,int Npole,int v,int p,int
r,int min,int max)
{
	int index;
	for (int i=0;(i<Nvil)&&((r>0)||(i==0));i++){
		if (((*vil)[v][i]!=0)&&(used[i]==0)){
			p+=(*vil)[v][i];
			if (p<=max) {
				if (p>=min) 
					index=find(pole,Npole,p);
				else
					index=-1;
				if ((index!=-1)&&(pole[index][2]==0)){
					r--;
					pole[index][2]=1;
				}
				used[i]=1;
				r=browse(vil,pole,used,Nvil,Npole,i,p,r,min,max);
				used[i]=0;
			}
			p-=(*vil)[v][i];	
		}		
	}
	return r;
}

int main()
{
	int N;
	//matica ci maju spolocnu hodnotu
	Pvil villages = (Pvil)malloc(sizeof(Tvil));
	int used[MAXVILLAGES];
	//ceny jednotlivych jazd
	Tpole queries;
	int queryNr=0;

	scanf("%i",&N);
	//vynulovanie
	for (int i=0;i<N;i++) for (int j=0;j<N;j++)
		(*villages)[i][j]=0;

	//ukladanie jednotlivych vetiev
	int c,d;
	int p;
	for (int i=0;i<N;i++){
		used[i]=0;
		p=1;
		do {
			if (p==1)
				scanf("%i",&d);
			else{
				scanf("%i",&c);
				(*villages)[i][d-1]=c;
				(*villages)[d-1][i]=c;
			}
			p=1-p;
		}while (d!=0);		
	};

	do {
		scanf("%i",&c);
		queries[queryNr][0]=c;
		queries[queryNr][2]=0;
		queries[queryNr][1]=queryNr;
		queryNr++;
	}while (c!=0);
	queryNr--;	

	sort(queries,0,queryNr-1,0);
	int count=queryNr+1;
	for (int i=0;(i<N)&&(count>0);i++){
count=browse(villages,queries,used,N,queryNr,i,0,count,0,queries[queryNr-1][0]);
	}
	sort(queries,0,queryNr-1,1);

	for (int i=0;i<queryNr;i++)
		if (queries[i][2]==1)
			printf("AYE\n");
		else 
			printf("NAY\n");

	return 0;
}